# React Bootstrap Button Component

> Learn how to use CoreUI’s React Button component with Bootstrap styling to build interactive, accessible, and responsive buttons for forms, tables, modals, and more.

## How to use React Bootstrap Button component

CoreUI provides a set of prebuilt React Button components styled with Bootstrap. Buttons signal actions to users and can initiate events both in the UI and behind the scenes.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonExample = () => {
  return (
    <>
      <CButton color="primary">Primary</CButton>
      <CButton color="secondary">Secondary</CButton>
      <CButton color="success">Success</CButton>
      <CButton color="danger">Danger</CButton>
      <CButton color="warning">Warning</CButton>
      <CButton color="info">Info</CButton>
      <CButton color="light">Light</CButton>
      <CButton color="dark">Dark</CButton>
      <CButton color="link">Link</CButton>
    </>
  )
}
```

> ## Disable text wrapping
> 
> To prevent text wrapping inside a button, apply the `.text-nowrap` class to the ``. Alternatively, set `$btn-white-space: nowrap` in Sass to apply it globally.
> 
> ## Button components
> 
> The `` component can render as a ``, ``, or `` element. When using it as an anchor for functionality (like toggles), add `role="button"` for accessibility.
> 
> ```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonComponentsExample = () => {
  return (
    <>
      <CButton as="a" color="primary" href="#" role="button">
        Link
      </CButton>
      <CButton type="submit" color="primary">
        Button
      </CButton>
      <CButton as="input" type="button" color="primary" value="Input" />
      <CButton as="input" type="submit" color="primary" value="Submit" />
      <CButton as="input" type="reset" color="primary" value="Reset" />
    </>
  )
}
```
> 
> ## Outline buttons
> 
> Use `variant="outline"` to create buttons with a transparent background and colored border — a more subtle alternative to standard buttons.
> 
> ```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonOutlineExample = () => {
  return (
    <>
      <CButton color="primary" variant="outline">
        Primary
      </CButton>
      <CButton color="secondary" variant="outline">
        Secondary
      </CButton>
      <CButton color="success" variant="outline">
        Success
      </CButton>
      <CButton color="danger" variant="outline">
        Danger
      </CButton>
      <CButton color="warning" variant="outline">
        Warning
      </CButton>
      <CButton color="info" variant="outline">
        Info
      </CButton>
      <CButton color="light" variant="outline">
        Light
      </CButton>
      <CButton color="dark" variant="outline">
        Dark
      </CButton>
    </>
  )
}
```
> 
> ## Ghost buttons
> 
> For minimal buttons with no background or border, use `variant="ghost"`. These are great for secondary actions.
> 
> ```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonGhostExample = () => {
  return (
    <>
      <CButton color="primary" variant="ghost">
        Primary
      </CButton>
      <CButton color="secondary" variant="ghost">
        Secondary
      </CButton>
      <CButton color="success" variant="ghost">
        Success
      </CButton>
      <CButton color="danger" variant="ghost">
        Danger
      </CButton>
      <CButton color="warning" variant="ghost">
        Warning
      </CButton>
      <CButton color="info" variant="ghost">
        Info
      </CButton>
      <CButton color="light" variant="ghost">
        Light
      </CButton>
      <CButton color="dark" variant="ghost">
        Dark
      </CButton>
    </>
  )
}
```
> 
> 
> Some button styles use light text colors and should be placed on dark backgrounds to maintain contrast.

## Sizes

Create large or small buttons with the `size="lg"` or `size="sm"` props.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonSizesExample = () => {
  return (
    <>
      <CButton color="primary" size="lg">
        Large button
      </CButton>
      <CButton color="secondary" size="lg">
        Large button
      </CButton>
    </>
  )
}
```

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonSizes2Example = () => {
  return (
    <>
      <CButton color="primary" size="sm">
        Small button
      </CButton>
      <CButton color="secondary" size="sm">
        Small button
      </CButton>
    </>
  )
}
```

You can also use CSS variables for fully custom sizes.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonSizes3Example = () => {
  const customVars = {
    '--cui-btn-padding-y': '.25rem',
    '--cui-btn-padding-x': '.5rem',
    '--cui-btn-font-size': '.75rem',
  } as React.CSSProperties

  return (
    <CButton color="primary" size="sm" style={customVars}>
      Custom button
    </CButton>
  )
}
```

## Shapes

### Pill buttons

Use pill-shaped buttons for a soft, rounded appearance.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonShapePillExample = () => {
  return (
    <>
      <CButton color="primary" className="rounded-pill">
        Primary
      </CButton>
      <CButton color="secondary" className="rounded-pill">
        Secondary
      </CButton>
      <CButton color="success" className="rounded-pill">
        Success
      </CButton>
      <CButton color="danger" className="rounded-pill">
        Danger
      </CButton>
      <CButton color="warning" className="rounded-pill">
        Warning
      </CButton>
      <CButton color="info" className="rounded-pill">
        Info
      </CButton>
      <CButton color="light" className="rounded-pill">
        Light
      </CButton>
      <CButton color="dark" className="rounded-pill">
        Dark
      </CButton>
      <CButton color="link" className="rounded-pill">
        Link
      </CButton>
    </>
  )
}
```

### Square buttons

Use square-shaped buttons for compact, uniform interactions.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonShapeSquareExample = () => {
  return (
    <>
      <CButton color="primary" className="rounded-0">
        Primary
      </CButton>
      <CButton color="secondary" className="rounded-0">
        Secondary
      </CButton>
      <CButton color="success" className="rounded-0">
        Success
      </CButton>
      <CButton color="danger" className="rounded-0">
        Danger
      </CButton>
      <CButton color="warning" className="rounded-0">
        Warning
      </CButton>
      <CButton color="info" className="rounded-0">
        Info
      </CButton>
      <CButton color="light" className="rounded-0">
        Light
      </CButton>
      <CButton color="dark" className="rounded-0">
        Dark
      </CButton>
      <CButton color="link" className="rounded-0">
        Link
      </CButton>
    </>
  )
}
```

## Disabled state

Disable any `<CButton>` by passing the `disabled` prop. This applies `pointer-events: none` and dims the button.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonDisabledExample = () => {
  return (
    <>
      <CButton color="primary" disabled>
        Primary button
      </CButton>
      <CButton color="secondary" disabled>
        Button
      </CButton>
      <CButton color="primary" variant="outline" disabled>
        Primary button
      </CButton>
      <CButton color="secondary" variant="outline" disabled>
        Button
      </CButton>
    </>
  )
}
```

Disabling anchor elements (`<a>`) requires additional steps: CoreUI applies the `.disabled` class, adds `aria-disabled="true"`, and sets `tabindex="-1"`.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonDisabled2Example = () => {
  return (
    <>
      <CButton as="a" href="#" color="primary" disabled>
        Primary link
      </CButton>
      <CButton as="a" href="#" color="secondary" disabled>
        Link
      </CButton>
    </>
  )
}
```

These steps prevent users from interacting with disabled links via keyboard or mouse.

## Block buttons

To make buttons span the full width of their container, use Bootstrap's layout utilities like `.d-grid`, `.w-100`, and `.col-*`.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonBlockExample = () => {
  return (
    <div className="d-grid gap-2">
      <CButton color="primary">Button</CButton>
      <CButton color="primary">Button</CButton>
    </div>
  )
}
```

Responsive layout: vertically stacked until the `md` breakpoint, where `.d-md-block` reverts to inline.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonBlock2Example = () => {
  return (
    <div className="d-grid gap-2 d-md-block">
      <CButton color="primary">Button</CButton> <CButton color="primary">Button</CButton>
    </div>
  )
}
```

You can also create column-based buttons using `.col-6` and center them with `.mx-auto`.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonBlock3Example = () => {
  return (
    <div className="d-grid gap-2 col-6 mx-auto">
      <CButton color="primary">Button</CButton>
      <CButton color="primary">Button</CButton>
    </div>
  )
}
```

Use flex utilities and margin helpers to align buttons horizontally when they're no longer stacked.

```html
import React from 'react'
import { CButton } from '@coreui/react'

export const ButtonBlock4Example = () => {
  return (
    <div className="d-grid gap-2 d-md-flex justify-content-md-end">
      <CButton color="primary" className="me-md-2">
        Button
      </CButton>
      <CButton color="primary">Button</CButton>
    </div>
  )
}
```

## API reference

See the full API reference for all available props in the Bootstrap-styled React Button component.

- [&lt;CButton /&gt;](../api/#cbutton)


# Vue Bootstrap Buttons Component

> Learn how to use CoreUI’s Vue Buttons component with Bootstrap styles for flexible, framework-consistent UI.

## Examples

CoreUI includes a bunch of predefined buttons components, each serving its own semantic purpose. Buttons show what action will happen when the user clicks or touches it. CoreUI buttons are used to initialize operations, both in the background or foreground of an experience.

```html
<template>
  <CButton color="primary" disabled>Primary</CButton>
  <CButton color="secondary">Secondary</CButton>
  <CButton color="success">Success</CButton>
  <CButton color="danger">Danger</CButton>
  <CButton color="warning">Warning</CButton>
  <CButton color="info">Info</CButton>
  <CButton color="light">Light</CButton>
  <CButton color="dark">Dark</CButton>
  <CButton color="link">Link</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

> Using color to add meaning only provides a visual indication, which will not be conveyed to users of assistive technologies – such as screen readers. Ensure that information denoted by the color is either obvious from the content itself (e.g. the visible text), or is included through alternative means, such as additional text hidden with the .visually-hidden class.

## Disable text wrapping

If you don't want the button text to wrap, you can add the `.text-nowrap` class to the `<CButton>`. In Sass, you can set `$btn-white-space: nowrap` to disable text wrapping for each button.

## Button components

The `<CButton>` component are designed for `<button>` ,  `<a>`  or  `<input>` elements (though some browsers may apply a slightly different rendering).

If you're using `<CButton>` component as `<a>` elements that are used to trigger functionality ex. collapsing content, these links should be given a `role="button"` to adequately communicate their meaning to assistive technologies such as screen readers.

```html
<template>
  <CButton as="a" color="primary" href="#" role="button">Link</CButton>
  <CButton type="submit" color="primary">Button</CButton>
  <CButton as="input" type="button" color="primary" value="Input" />
  <CButton as="input" type="submit" color="primary" value="Submit" />
  <CButton as="input" type="reset" color="primary" value="Reset" />
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

## Outline buttons

### Base outline style

The `variant="outline` property provides a neutral outline button style without any color modifiers. It’s useful as a foundation for minimal buttons without background color or strong visual emphasis.

```html
<template>
  <CButton variant="outline">Base outline button</CButton>
  <CButton variant="outline" active>Active state</CButton>
  <CButton variant="outline" disabled>Disabled state</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

These Vue buttons use a transparent background, subtle border, and inherit text color from the parent context. They’re best suited for minimalist UI elements like modals, toolbars, or secondary actions.

### Themed outline variants

If you need a button, but without the strong background colors, set `color` and `variant=" outline"` props to remove all background colors.

```html
<template>
  <CButton color="primary" variant="outline">Primary</CButton>
  <CButton color="secondary" variant="outline">Secondary</CButton>
  <CButton color="success" variant="outline">Success</CButton>
  <CButton color="danger" variant="outline">Danger</CButton>
  <CButton color="warning" variant="outline">Warning</CButton>
  <CButton color="info" variant="outline">Info</CButton>
  <CButton color="light" variant="outline">Light</CButton>
  <CButton color="dark" variant="outline">Dark</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

These outline variants of our Vue.js buttons retain transparent backgrounds by default, but display a background tint on hover or focus to indicate interactivity. They’re ideal for secondary actions when you want to differentiate from the standard buttons visually.

## Ghost buttons

### Base ghost style

Use the `variant="ghost"` property to create ultra-minimalist buttons with no borders and a fully transparent background. These Vue buttons rely solely on text color for visibility and apply a background highlight when hovered over or in an active state.

They’re perfect for interfaces where you want buttons to be present but visually unobtrusive—such as action buttons in modals, cards, or toolbars.

If you need a ghost variant of button, set `variant="ghost"` prop to remove all background colors.

```html
<template>
  <CButton variant="ghost">Base ghost button</CButton>
  <CButton variant="ghost" active>Active state</CButton>
  <CButton variant="ghost" disabled>Disabled state</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

To apply theme colors to Vue ghost buttons, use the `color` and `variant="ghost"` properties. By default, these variants color only the text. On hover or focus, they add a background that corresponds to the theme color.

```html
<template>
  <CButton color="primary" variant="ghost">Primary</CButton>
  <CButton color="secondary" variant="ghost">Secondary</CButton>
  <CButton color="success" variant="ghost">Success</CButton>
  <CButton color="danger" variant="ghost">Danger</CButton>
  <CButton color="warning" variant="ghost">Warning</CButton>
  <CButton color="info" variant="ghost">Info</CButton>
  <CButton color="light" variant="ghost">Light</CButton>
  <CButton color="dark" variant="ghost">Dark</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

> Some of the button styles use a relatively light foreground color, and should only be used on a dark background in order to have sufficient contrast.

## Sizes

Larger or smaller buttons? Add `size="lg"` or `size="sm"` for additional sizes.

```html
<template>
  <CButton color="primary" size="lg">Large button</CButton>
  <CButton color="secondary" size="lg">Large button</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

## Shapes

### Pill buttons

```html
<template>
  <CButton color="primary" shape="rounded-pill">Primary</CButton>
  <CButton color="secondary" shape="rounded-pill">Secondary</CButton>
  <CButton color="success" shape="rounded-pill">Success</CButton>
  <CButton color="danger" shape="rounded-pill">Danger</CButton>
  <CButton color="warning" shape="rounded-pill">Warning</CButton>
  <CButton color="info" shape="rounded-pill">Info</CButton>
  <CButton color="light" shape="rounded-pill">Light</CButton>
  <CButton color="dark" shape="rounded-pill">Dark</CButton>
  <CButton color="link" shape="rounded-pill">Link</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

### Square buttons

```html
<template>
  <CButton color="primary" shape="rounded-0">Primary</CButton>
  <CButton color="secondary" shape="rounded-0">Secondary</CButton>
  <CButton color="success" shape="rounded-0">Success</CButton>
  <CButton color="danger" shape="rounded-0">Danger</CButton>
  <CButton color="warning" shape="rounded-0">Warning</CButton>
  <CButton color="info" shape="rounded-0">Info</CButton>
  <CButton color="light" shape="rounded-0">Light</CButton>
  <CButton color="dark" shape="rounded-0">Dark</CButton>
  <CButton color="link" shape="rounded-0">Link</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

## Disabled state

Add the `disabled` boolean prop to any `<CButton>` component to make buttons look inactive. Disabled button has `pointer-events: none` applied to, disabling hover and active states from triggering.

```html
<template>
  <CButton color="primary" size="lg" disabled>Primary button</CButton>
  <CButton color="secondary" size="lg" disabled>Button</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

Disabled buttons using the `<a>` component act a little different:

`<a>`s don't support the `disabled` attribute, so CoreUI has to add `.disabled` class to make buttons look inactive. CoreUI also has to add to the disabled button component `aria-disabled="true"` attribute to show the state of the component to assistive technologies.

```html
<template>
  <CButton as="a" href="#" color="primary" size="lg" disabled>Primary link</CButton>
  <CButton as="a" href="#" color="secondary" size="lg" disabled>Link</CButton>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

The `.disabled` class uses `pointer-events: none` to try to disable the link functionality of `<a>`s, but that CSS property is not yet standardized. Besides, even in browsers that do support `pointer-events: none`, keyboard navigation remains unaffected, meaning that sighted keyboard users and users of assistive technologies will still be able to activate these links. So to be safe, we automatically add a `tabindex="-1"` attribute on disabled links (to prevent them from receiving keyboard focus) and use custom JavaScript to disable their functionality.

## Block buttons

Create buttons that span the full width of a parent—by using utilities.

```html
<template>
  <div class="d-grid gap-2">
    <CButton color="primary">Button</CButton>
    <CButton color="primary">Button</CButton>
  </div>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

Here we create a responsive variation, starting with vertically stacked buttons until the `md` breakpoint, where `.d-md-block` replaces the `.d-grid` class, thus nullifying the `gap-2` utility. Resize your browser to see them change.

```html
<template>
  <div class="d-grid gap-2 d-md-block">
    <CButton color="primary">Button</CButton>
    <CButton color="primary">Button</CButton>
  </div>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

You can adjust the width of your block buttons with grid column width classes. For example, for a half-width "block button", use `.col-6`. Center it horizontally with `.mx-auto`, too.

```html
<template>
  <div class="d-grid gap-2 col-6 mx-auto">
    <CButton color="primary">Button</CButton>
    <CButton color="primary">Button</CButton>
  </div>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>

Additional utilities can be used to adjust the alignment of buttons when horizontal. Here we've taken our previous responsive example and added some flex utilities and a margin utility on the button to right align the buttons when they're no longer stacked.

```html
<template>
  <div class="d-grid gap-2 d-md-flex justify-content-md-end">
    <CButton color="primary" class="me-md-2">Button</CButton>
    <CButton color="primary">Button</CButton>
  </div>
</template>

<script setup>
import { CButton } from '@coreui/vue'
</script>
```
  
</Example>
